﻿/*
 *      Studente: Andrea ARTUSO
 *      Classe: 4AIN
 *      A.S: 2022/2023
 *      
 *      Classe per la gestione dell'algoritmo di Dijkstra
 *      
 *      Ultima modifica: 03/05/2023
 */

using Priority_Queue;
using System;

namespace AlgoritmoDijkstraWPF
{
    class Dijkstra
    {
        // Struttura utilizzata per contenere le informazioni di ogni nodo
        public struct Nodo
        {
            public int id;
            public long costo;
            public int? prec;
            public bool processato;

            public Nodo(int i, int c, int? p)
            {
                id = i;
                costo = c;
                prec = p;
                processato = false;
            }
        }

        // Algoritmo di Dijkstra partendo da una matrice delle adiacenze
        public static void Risolvi(int[,] mat, Nodo[] grafo, int N)
        {
            SimplePriorityQueue<Nodo> coda = new SimplePriorityQueue<Nodo>();

            coda.Enqueue(grafo[0], grafo[0].costo);

            while (coda.Count != 0)
            {
                Nodo t = coda.Dequeue();

                int id = t.id;
                Console.WriteLine("Estratto nodo {0}", id);
                for (int i = 0; i < N; i++)
                {
                    if (!grafo[i].processato)
                    {
                        Console.WriteLine("Processando nodo {0}", i);
                        long costo = t.costo + mat[id, i];
                        Console.WriteLine("costo = {0} + {1}", t.costo, mat[id, i]);

                        if (costo < grafo[i].costo)
                        {
                            grafo[i].costo = costo;
                            grafo[i].prec = id;
                            coda.Enqueue(grafo[i], grafo[i].costo);
                        }
                    }

                    grafo[id].processato = true;
                }
            }
        }
    }
}
